/*
copyright 2010 Chris Glasier 
coding advice by Jim Foltz 
code check JSLint 6 March 2010
*/
/*global
config,nset,noldDown,moldDown,coreDold,fList,interSync,fPrompts,fOptions,confirmDown
*/

function coreDown2(params){
	switch(params[1]){
		case "nold"	: noldDown(params); break;
		case "mold"	: moldDown(params); break;
		case "dold"	: coreDold(params); break;
	}
}

function easeQuadOut(t, b, c, d) {
	return -c * (t/=d)*(t-2) + b;
}

function linearTween(t, b, c, d) { 
	return c*t/d + b; 
}

function coreAnimate(obj, elm, begin, end, duration, fps, sw, params) {
	var change,interval,steps,i;
	change      = end-begin;
	interval    = Math.ceil(1000/fps);
	steps		= Math.ceil(duration/interval);
	if(obj.coreStop){
		clearInterval(obj.coreStop);
	}
	i = 0;
    obj.coreStop = setInterval(
	function() { 
		obj.last = linearTween(i, begin, change, steps);
		obj.style[elm]  = obj.last + 'px'; 
		i+=1;
		if (i > steps){
			clearInterval(obj.coreStop);
			if(sw === 1){
				coreDown2(params);
			}
		}
	} 
	,interval);
}

function coreDown(cell , c , dv ){
	var slider,sliderName,sliderNo,p,s,sx,a,cellTop,sliderTop,st,dist,fin,cnt,elm,params,spd; 
	slider		= cell.parentNode;
	sliderName	= dv;
	sliderNo	= c;
	p			= slider.id.charAt(0);
	if(slider.parentNode === "nold"){
		s		= config.select;
		if(s[0] === "Block" || s[0] === "Multiple"){
			sx = 0;
		}
		else{
			sx = 1;
		}
	}
	else{
		sx = 1;
	}
	//Allows multiple hiliting for multi selection functions
	if(sx === 1){
		for(a=0; a < slider.childNodes.length; a+=1){
			slider.childNodes[a].className = p+"bdr";
		}
		cell.className	= p + "bgc";
	}
	cellTop		= cell.offsetTop;
	sliderTop	= slider.offsetTop;
	st			= Math.round(document.body.clientHeight/2);
	dist		= cellTop + sliderTop - st;
	fin			= sliderTop - dist;
	elm			= "top";
	if(cellTop + sliderTop === st){
		cnt = 1;
	}
	else{
		cnt = 0;
	}
	params = [cell ,  sliderName , sliderNo , cnt , fin];
	spd = config.animate;
	coreAnimate(slider, elm, sliderTop, fin, spd, 20, 1, params);
}

function coreSliderHolder(c , cw , dv , t){
	var o = document.createElement("div");
	document.getElementById(dv).appendChild(o);
	o.id = dv + c; 
	o.style.left = cw * c + "px" ;
	o.style.top = t + "px";
	o.style.width = cw;
}	

function coreNsetSlider(list , dv , c , json , tt) {
	var f,ch,cl,st,slider,k,n,ent,d,o,p,cn,s;
	f = config;
	ch = f.cellheight;
	cl = f.columns;
	st		= Math.round(document.body.clientHeight/2);
	slider	= document.getElementById(dv + c);
	slider.innerHTML = "";
	k = [];
	for (n in list) {
	//alert(JSON.stringify(json[list[n]]))
	if(json[list[n]].hasOwnProperty("Name") || json[list[n]].hasOwnProperty("Filter")){
			ent = [json[list[n]].Name , list[n] , json[list[n]].Filter];
			k.push(ent);
		}
	}
	for(d = 0; d < k.length; d+=1){
		o = document.createElement("div");
		document.getElementById(dv+c).appendChild(o);
		p  = dv.charAt(0);
		o.id = p + k[d][1];
		o.title = o.id;	//testing
		o.innerHTML = k[d][0];
		if(o.offsetParent.offsetTop + o.offsetTop === st && dv === "nold" ){
			cn = "bgc";
		}
		else{
			cn = "bdr";
		}
		if(dv === "nold" && c === tt.length-1){
			cn = "bdr";
		}
		o.className = p + cn;
		o.onmousedown = function() { coreDown(this , c , dv ); };
		s = o.style;
		s.width = "100%";
		s.height = ch;
		if(json[k[d][1]].Type === "Header"){
			s.color = "red";
		}
		if(json[k[d][1]].Filter){
			s.textDecorationLineThrough = true;
		}
	}
}

function coreConfirmHide(){
	document.getElementById("confirm").style.display = "none";
}

//Slides the menu panel to show/hide underlying device menu(s)
function coreShutter(amt){
	var obj,start,fin;
	obj		= document.getElementById("mold");
	start	= parseInt(obj.style.left,10);
	fin		= (config.columns - amt) * config.colwidth;
	coreAnimate(obj , "left" , start, fin , 300, 20, 0 );
}

//sets layout for 2 column device (start and resize)
function coreLayout(cl , cw , dev , dt){
	var f,mc,st,d,dl,a,da;
	f	= config;
	cl	= f.columns;
	cw	= f.colwidth;
	dt	= f.devicetrail;
	mc	= f.menucolumns;
	st	= f.stripetop;
	d	= document.getElementById("dold");
	coreShutter(dt[2]);
	dl =  (cl - mc) * cw;
	d.style.left = dl;
	d.style.width = cw * 2 +"px";
	for(a = 0; a < 2; a +=1){
		da = document.getElementById("dold"+a).style;
		da.left		= cw * a + "px";
		da.top		= st - dt[a][1] + "px";
		da.width	= cw;
	}
	coreConfirmHide(); 
}

// Used for plain lists created in devices
function corePlainSlider(c , dt , list , pan, caps){
	var sld,a,o,s;
	sld = document.getElementById(pan);
	sld.innerHTML = "";
	sld.style.top = config.stripetop - dt[c][1] + "px"; 
	for(a = 0; a < list.length; a +=1){
		o = document.createElement("div");
		sld.appendChild(o); 
		if(!list[a][0]){
			o.id		= list[a];
			o.innerHTML = list[a];
		}
		else{
			o.id = list[a][0];
			o.innerHTML = list[a][1];
		}
	if(caps){
		o.innerHTML = o.innerHTML.toUpperCase();
	}
	o.title = o.id;
	o.className = "dbdr";
	o.onmousedown = function() { coreDown(this , c , "dold" ); };
	s = o.style;
	s.width = "100%";
	s.height = config.cellheight;
	}
}

function coreLinksList(sh,list,nr){
	var dt,pan,coll,r,a;
	coreShutter(sh);
	dt = config.devicetrail;
	config.devicetrail[2] = sh;
	pan = "dold"+nr;
	corePlainSlider(1 , dt , list , pan);
	coll = document.getElementById(pan).childNodes;
	r = config.active;
	for(a = 0; a < coll.length; a += 1){
		if(coll[a].innerHTML === config.select[0]){
				coll[a].style.color = "red";
		}
	}
}

//for 2 column device
function coreRun2(cl, cw , d){
	var c,o,s,list,offset,dt,pan;
	d = document.getElementById("dold");
	cw = config.colwidth;
	for(c = 0 ; c < 2 ; c += 1){
		o = document.createElement("div");
		d.appendChild(o);
		o.id	= "dold" + c;
		s		= o.style;
		s.left	= cw * c + "px" ;
		s.width = cw + "px" ;
	}
	list	= fList("Main");
	offset	= Math.floor(list.length/2) * config.cellheight;
	dt		= [];
	dt[0]	= [null,offset];
	dt[1]	= [null,0];
	dt[2]	= 1;
	coreShutter(1);
	config.devicetrail = dt;
	pan = "dold0";
	corePlainSlider(0 , dt , list , pan);
	coreLayout(cl , cw , d, dt);
}


function coreLinks(cell,cnt){
	var coll,a,typ,obj,lgth,o,t,holder;
	coll = cell.parentNode.childNodes;
	for(a = 0; a < coll.length; a += 1){
		coll[a].className = "dbdr";
		if(coll[a].innerHTML === cell.innerHTML){
			coll[a].style.color = "red";
			config.select[0] = cell.innerHTML;
		}
		else{
			coll[a].style.color = "darkgreen";
		}
	}
	typ = cell.innerHTML;
		if(typ === "Change link" || typ === "Cross link"){
		if(!config.select[2]){
			return;
		}
		coll = config.select[2];
		obj = document.createElement("div");
		document.getElementById("dold").appendChild(obj); 
		obj.id = "inter";
		lgth = coll.length-1;
		obj.style.top = config.stripetop - lgth/2 * config.cellheight;
		for(a = 0; a < coll.length; a += 1){
			o = document.createElement("div");
			obj.appendChild(o);
			o.id	= coll[a];
			o.title = o.id;
			o.innerHTML = nset[coll[a]].Name;
			o.className = "trans";
			t = o.style;
			t.width = config.colwidth;
			t.height = config.cellheight;
		}
	}
	if(typ === "Cancel"){
		if(document.getElementById("inter")){
			obj		= document.getElementById("inter");
			holder	= document.getElementById("dold");
			holder.removeChild(obj);
		}
		config.select[0] = "Single";
	}
}	
	
function coreInteractorsList(sh, list, nr){
	var dt,pan,coll,r,a,b;
	coreShutter(sh);
	dt = config.devicetrail;
	config.devicetrail[2] = sh;
	pan = "dold"+nr;
	corePlainSlider(1 , dt , list , pan);
	coll = document.getElementById(pan).childNodes;
	r = config.active;
	for(a = 0; a < coll.length; a += 1){
		for(b = 0; b < r.length; b += 1){
			if(coll[a].innerHTML === r[b][0]){
				coll[a].style.color = "red";
			}
		}
	}
}

function coreInteractors(cell,cnt){
	var r,ind,a;
	if(cnt === 0){
		return;
	}
	r = config.active;
	ind = null;
	for(a = 0; a < r.length; a += 1){
		if(r[a][0] === cell.innerHTML){
			ind = a;
		}
	}
	if(ind === null){
		r.push([cell.innerHTML]);
		cell.style.color = "red";
	}
	else{
		r.splice(ind,1);
		cell.style.color = "darkgreen";
	}
	interSync(cell);   // SU to nset interactor
}
			
function coreSupportFiles(list){
	var holder,a,obj;
	holder = document.getElementById("deviceScript"); 
	for(a in list){
		obj = document.createElement("script");
		holder.appendChild(obj);
		obj.src = list[a]+".js";
	}
}


//device events
function coreDold0(prm){				//prm = cell, sliderName , sliderNo ,  cnt , fin 
	var cell,cTop,cnt,dt,nt,node;
	cell		= prm[0];
	cTop		= cell.offsetTop;
	cnt			= prm[3];
	dt			= [];
	dt[0]		= [cell.id,cTop];
	dt[1]		= [null,0];
	dt[2]		= 1;
	coreShutter(1);
	config.devicetrail = dt;
	nt		= config.nametrail;
	node	= nt[nt.length-1][0];
	fPrompts(cell,cnt,node);
}

function coreDold1(prm){
	var f,nt,st,cell,cnt,node; 
	f = config;
	nt		= f.nametrail;
	st		= f.stripetop;
	cell	= prm[0]; 
	cnt		= prm[3];
	config.devicetrail[1][1] = st - prm[4]; 
	node	= nt[nt.length-1][0];
	fOptions(cell,cnt,node);
}

function coreDold(prm){
	if(prm[2] === 0){
		coreDold0(prm);
	}
	else{
		coreDold1(prm);
	}
}

//input/confirm/save word or number
function coreInput(dev){
	var f,ch,cw,st,o,p,s;
	f	= config;
	ch	= f.cellheight;
	cw	= f.colwidth;
	st	= f.stripetop;
	o = document.createElement("div");
	dev.appendChild(o); 
	o.id = "confirm"; o.className = "confirm"; s = o.style;
	s.top = 0 + "px"; s.width = cw +"px"; s.height = ch +"px"; s.display = "none"; s.zIndex	= 1;
	p = document.createElement("div"); 
	o.appendChild(p);
	p.id = "inp"; p.contentEditable = true; s = p.style;
	s.cursor = "text"; s.textAlign = "right"; s.width = "75%"; s.height = "100%"; s.overflow = "hidden";
	p = document.createElement("div");
	o.appendChild(p);
	p.id = "ok"; p.innerHTML = "&larr;"; p.onmousedown = function() { confirmDown(); };
	s = p.style; s.left	= "75%"; s.width = "25%"; s.textAlign = "center";
}

//Uses length of nset to make unique number label
function coreLength(){
	var lgth, n;
	lgth = 0;
	for(n in nset){ 
		lgth += 1; 
	}
	return(lgth);
}

function coreSetup(){
	var f,cl,cw,mc,d,s;
	f	= config;
	cl	= f.columns;
	cw	= f.colwidth;
	mc	= f.menucolumns;
	d	= document.getElementById("dold"); 
	d.innerHTML = "";
	s = d.style;
	s.left	= (cl - mc) * cw;
	s.width	= cw * 2;
	s.height	= "100%";
	s.display = "block";
}

function coreCleanup(){	
	var obj,par,f;
	obj = document.getElementById("confirm");
	par = obj.parentNode;
	par.removeChild(obj);
	coreShutter(2);
	f = config;
	delete f.opendevice;
	delete f.active;
	f.devicetrail = [];
}


