=begin
Copyright 2010, Chris Glasier 
Code advice by Jim Foltz
=end

require 'sketchup.rb'

if (not file_loaded?("nsetSketchup.rb"))
    UI.menu("Plugins").add_item("NSET" ){ NsetSketchupMod.start }
end

class NsetSketchupModSelectionObserver < Sketchup::SelectionObserver
    # 
    attr_reader :selected
    def initialize
        @selected = "off"
    end
    def onSelectionBulkChange(selection)
	    NsetSketchupMod.selection_bulk_change(selection)
    end  # def
end  # class

module NsetSketchupMod

    def NsetSketchupMod.selection_bulk_change(selection)
		model = Sketchup.active_model
        entities = model.entities
		selection = model.selection 
		entity = selection[0]
		@ind = entity.get_attribute "indexes", "ind"
		p @selected
		if @selected == "on"
			@dlg.execute_script("interRec('#{@ind}');")
		end
    end

    def NsetSketchupMod.start
		
		@NsetSketchupModSelectionObserver ||= NsetSketchupModSelectionObserver.new
		
		Sketchup.active_model.selection.add_observer(@NsetSketchupModSelectionObserver)

		Sketchup.send_action "selectSelectionTool:"
		
		@dlg = UI::WebDialog.new("NSET", true, "NSET", 300, 345, 0, 0, true)
        subDir = "nset/"
        fileName = "machine.htm"
        @dlg.set_file File.join(File.dirname(__FILE__), subDir+fileName)
		
		 @dlg.add_action_callback("size") {|d, p|
            a = p.split(",")
            w = Integer(a[0])
            h = Integer(a[1])
            @dlg.set_size w,h
		}	
		
		@dlg.add_action_callback("sync") { |d, a|
		@selected = a.to_s
		p @selected
		}

		@dlg.add_action_callback("import") { |d, a|
		model = Sketchup.active_model
		pages = model.pages
		entities = model.entities
		@carray	= []
		@darray	= []
		@tarray	= []
		larray	= []
		a = 0
		entities.each do |entity|
		if  entity.class == Sketchup::ComponentInstance || entity.class == Sketchup::Group
				entity.visible = true
				name = entity.name
				layer = entity.layer
				lname = layer.name
				layer.visible = true
				if  entity.class == Sketchup::ComponentInstance
						defin = entity.definition.name
						if entity.name == ""
							entity.name = defin
							name = defin
						end
					end
					if  entity.class == Sketchup::Group
						if name == ""
							entity.name = "Unnamed"
							name = entity.name
						end
					end
				entity.name = name
				entity.set_attribute "indexes", "ind", Integer(a)
				entry = [defin,name,lname,Integer(a)]
				status1 = entity.visible?
				status2 = layer.visible?
				
				@carray.push(entry.join(","))
			end
			if  entity.typename=="DimensionLinear" || entity.typename=="DimensionRadial"
				entity.layer.visible = true
				@darray.push(entity.layer.name)
			end
			if  entity.class == Sketchup::Text
				entity.layer.visible = true
				@tarray.push(entity.layer.name)
			end
			a += 1
		end
		pages	= model.pages
		layers	= model.layers
		styles	= model.styles
		@parray	=[]
		pages.each do |page|
			model.pages.selected_page = page
			cam	 = page.camera
			name = page.name
			pl = []
				page.layers.each do |layer|
					pl.push(layer.name)
				end
			pl = pl.join(",")
			st = page.style
			st = st.name
			pts = [cam.eye, cam.target, cam.up]
			if name == "Wall dims"
				
				p cam.eye 
				p cam.target
				p cam.up
			end
			per = cam.perspective?
			if(cam.perspective?)
				fov = cam.fov
				sub = [pts,per,fov]
			else
				sub = [pts,per]
			end
			sub = sub.join("yy")
			#p [name,per] 
			entry = [name,pl,st,sub]
			@parray.push(entry.join("xx"))	
			
		end
		if !pages["Nameset"]
			pages.add "Nameset"
		end
		page = model.pages.selected_page
		page.update  
		c	= @carray.join(";")
		d	= @darray.join(",")
		t	= @tarray.join(",")
		p	= @parray.join(";")
		array = [c,d,t,p]
		array = array.join("|")
		#p array
		cmd = "fImportReturn('#{array}');"
        @dlg.execute_script (cmd)      
		}
		
		@dlg.add_action_callback("send") { |d, a|
			subDir = "nset/"
			ret = a.split(";")
			file	= ret[0]
			file = File.join(File.dirname(__FILE__), subDir, file + ".json")
			f = File.open(file, 'r') 
			line = f.gets
			f.close
			ret = ret.join(",")
			array = [line,ret]
			array = array.join(";")
			script = "rubyReceive('#{array}')";
			#p array
			d.execute_script(script)
		}
		
		@dlg.add_action_callback("save") { |d, a|
			p = @dlg.get_element_value("trans")
			file = a.to_s
			subDir = "nset/"
			file = File.join(File.dirname(__FILE__), subDir, file +".json")
			f = File.open(file, 'w')
			f.write p
			f.close
			puts p
		}
		
	@dlg.add_action_callback("loose") {|d, p|
		model = Sketchup.active_model
		entities = model.entities
	    entities.each do |entity|
			if  entity.class == Sketchup::Edge || entity.class == Sketchup::Face
				entity.visible = true
			else
				entity.visible = false
			end
		end
		}
	
	@dlg.add_action_callback("mixed") {|d, p|
		mix = @dlg.get_element_value("trans")
		mix = mix.split(",")
		model = Sketchup.active_model
		layers = model.layers
		layers.each do |layer|
		layer.visible = false
		end	
		mix.each do |m|
			layers[m].visible = true
		end	
		}
		
	@dlg.add_action_callback("unnamed") {|d, p|
		model = Sketchup.active_model
		layers = model.layers
		selection = model.selection
		layers.each do |layer|
		layer.visible = false
		end	
		entities	= model.entities
		entities.each do |entity|
			if  entity.class == Sketchup::Group
				if entity.name == "Unnamed"
					selection.add entity
					entity.visible = true
					entity.layer.visible = true
				end
			end
		end
		}
	
	
	
	@dlg.add_action_callback("group") {|d, p|
		model = Sketchup.active_model
		layers = model.layers
		selection = model.selection
		layers.each do |layer|
		layer.visible = false
		end	
		entities	= model.entities
		entities.each do |entity|
			if  entity.class == Sketchup::Group
				selection.add entity
				entity.visible = true
				entity.layer.visible = true
			end
		end
		}
	
	@dlg.add_action_callback("scene") {|d, p|
		a = @dlg.get_element_value("trans")
		a = a.split("|")
		name	= a[0].split(",")
		lyrs	= a[1].split(",")
		cmps	= a[2].split(",")
		sty		= a[3].to_s
		cam		= a[4].split(",")
		model	= Sketchup.active_model
		entities	= model.entities
		entities.each do |entity|
			if  entity.class == Sketchup::ComponentInstance || entity.class == Sketchup::Group
				entity.visible = false
			end
		end
		cmps.each do |c|
			a = Integer(c)
			#p entities[a].name
			entities[a].visible = true
		end
		layers = model.layers
		layers.each do |layer|
		layer.visible = false 
		end	
		lyrs.each do |lyr|
			layers[lyr].visible = true;
			#p layers[lyr].name
		end	
		pages	= model.pages
		styles	= model.styles
		page	= pages["Nameset"]
		styles.selected_style= styles[sty]
		page.use_style = styles.selected_style
		eye		= Geom::Point3d.new [Float(cam[0]).mm, Float(cam[1]).mm, Float(cam[2]).mm]
		target	= Geom::Point3d.new [Float(cam[3]).mm, Float(cam[4]).mm, Float(cam[5]).mm]
		up	= Geom::Vector3d.new [Float(cam[6]), Float(cam[7]), Float(cam[8])]
		camera = model.active_view.camera
		p "Recreated"
		p eye 
		p target
		p up
		camera.set(eye,target,up)
		if cam[9] == "true"
			camera.perspective = true
		else
			camera.perspective = false
		end
		if camera.perspective?
			camera.fov = Float(cam[10])
		end
	}	
	
	 @dlg.add_action_callback("hilite") {|d, p|
            entityNo =  Integer(p)
            model = Sketchup.active_model
            entities = model.active_entities
            entity = entities[entityNo]
            selection = model.selection
            selection.clear
            selection.add entity
	}
		
		
	#	@dlg.set_on_close{ |d, a|
	#		@dlg.execute_script("macFinish()")
	#	}
		
        @dlg.show{}
			
	end # def nsetSketchupMod.start

end # module nsetSketchupMod

file_loaded("nsetSketchup.rb")
